/**
 * DevExtreme (cjs/renovation/ui/scheduler/workspaces/props.js)
 * Version: 21.2.0 (build 21230-1556)
 * Build date: Wed Aug 18 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.CurrentViewConfigType = exports.WorkSpaceProps = void 0;
var _date = _interopRequireDefault(require("../../../../core/utils/date"));
var _base_props = require("../../common/base_props");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}
var WorkSpaceProps = _extends({}, _base_props.BaseWidgetProps, {
    intervalCount: 1,
    groups: [],
    groupByDate: false,
    groupOrientation: "horizontal",
    crossScrollingEnabled: false,
    startDayHour: 0,
    endDayHour: 24,
    firstDayOfWeek: 0,
    hoursInterval: .5,
    showAllDayPanel: false,
    allDayPanelExpanded: false,
    allowMultipleCellSelection: true,
    indicatorTime: new Date,
    indicatorUpdateInterval: 5 * _date.default.dateToMilliseconds("minute"),
    shadeUntilCurrentTime: true,
    selectedCellData: [],
    scrolling: {
        mode: "standard"
    },
    cellDuration: 30,
    showCurrentTimeIndicator: true,
    type: "week"
});
exports.WorkSpaceProps = WorkSpaceProps;
var CurrentViewConfigType = {
    intervalCount: WorkSpaceProps.intervalCount,
    groups: WorkSpaceProps.groups,
    groupByDate: WorkSpaceProps.groupByDate,
    groupOrientation: WorkSpaceProps.groupOrientation,
    crossScrollingEnabled: WorkSpaceProps.crossScrollingEnabled,
    startDayHour: WorkSpaceProps.startDayHour,
    endDayHour: WorkSpaceProps.endDayHour,
    firstDayOfWeek: WorkSpaceProps.firstDayOfWeek,
    hoursInterval: WorkSpaceProps.hoursInterval,
    showAllDayPanel: WorkSpaceProps.showAllDayPanel,
    allDayPanelExpanded: WorkSpaceProps.allDayPanelExpanded,
    allowMultipleCellSelection: WorkSpaceProps.allowMultipleCellSelection,
    indicatorTime: WorkSpaceProps.indicatorTime,
    indicatorUpdateInterval: WorkSpaceProps.indicatorUpdateInterval,
    shadeUntilCurrentTime: WorkSpaceProps.shadeUntilCurrentTime,
    selectedCellData: WorkSpaceProps.selectedCellData,
    scrolling: WorkSpaceProps.scrolling,
    cellDuration: WorkSpaceProps.cellDuration,
    showCurrentTimeIndicator: WorkSpaceProps.showCurrentTimeIndicator,
    type: WorkSpaceProps.type,
    focusStateEnabled: WorkSpaceProps.focusStateEnabled,
    tabIndex: WorkSpaceProps.tabIndex
};
exports.CurrentViewConfigType = CurrentViewConfigType;
