/**
 * DevExtreme (cjs/ui/pivot_grid/utils/get_scrollbar_info.js)
 * Version: 21.2.0 (build 21230-1556)
 * Build date: Wed Aug 18 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.getScrollBarInfo = getScrollBarInfo;
var _renderer = _interopRequireDefault(require("../../../core/renderer"));
var _get_scrollbar_width = require("./get_scrollbar_width");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}
var scrollBarInfoCache = {};

function getScrollBarInfo(useNative) {
    if (scrollBarInfoCache[useNative]) {
        return scrollBarInfoCache[useNative]
    }
    var $dummyContainer = (0, _renderer.default)("<div>").appendTo("body");
    try {
        var scrollBarWidth;
        var options = {};
        var $dummyScrollable = (0, _renderer.default)("<div>").css({
            position: "absolute",
            visibility: "hidden",
            top: -1e3,
            left: -1e3,
            width: 100,
            height: 100
        }).appendTo($dummyContainer);
        (0, _renderer.default)("<p>").css({
            width: "100%",
            height: 200
        }).appendTo($dummyScrollable);
        if ("auto" !== useNative) {
            options.useNative = !!useNative;
            options.useSimulatedScrollbar = !useNative
        }
        var scrollable = $dummyScrollable.dxScrollable(options).dxScrollable("instance");
        var scrollBarUseNative = scrollable.option("useNative");
        scrollBarWidth = scrollBarUseNative ? (0, _get_scrollbar_width.getScrollbarWidth)((0, _renderer.default)(scrollable.container()).get(0)) : 0;
        scrollBarInfoCache[useNative] = {
            scrollBarWidth: scrollBarWidth,
            scrollBarUseNative: scrollBarUseNative
        }
    } finally {
        $dummyContainer.remove()
    }
    return scrollBarInfoCache[useNative]
}
