/**
 * DevExtreme (esm/renovation/ui/scheduler/appointment/layout.js)
 * Version: 21.2.0 (build 21230-1556)
 * Build date: Wed Aug 18 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["items"];
import {
    createVNode,
    createComponentVNode
} from "inferno";
import {
    InfernoWrapperComponent
} from "@devextreme/vdom";
import {
    Appointment
} from "./appointment";
import {
    getAppointmentKey
} from "./utils";
export var viewFunction = _ref => {
    var {
        props: {
            items: items
        }
    } = _ref;
    return createVNode(1, "div", "dx-scheduler-appointments", items.map(item => createComponentVNode(2, Appointment, {
        viewModel: item
    }, getAppointmentKey(item))), 0)
};
export var AppointmentLayoutProps = {
    items: []
};
import {
    createReRenderEffect
} from "@devextreme/vdom";
export class AppointmentLayout extends InfernoWrapperComponent {
    constructor(props) {
        super(props);
        this.state = {}
    }
    createEffects() {
        return [createReRenderEffect()]
    }
    get restAttributes() {
        var _this$props = this.props,
            restProps = _objectWithoutPropertiesLoose(_this$props, _excluded);
        return restProps
    }
    render() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            restAttributes: this.restAttributes
        })
    }
}
AppointmentLayout.defaultProps = _extends({}, AppointmentLayoutProps);
