/**
 * DevExtreme (esm/renovation/ui/scheduler/workspaces/props.js)
 * Version: 21.2.0 (build 21230-1556)
 * Build date: Wed Aug 18 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _extends from "@babel/runtime/helpers/esm/extends";
import dateUtils from "../../../../core/utils/date";
import {
    BaseWidgetProps
} from "../../common/base_props";
export var WorkSpaceProps = _extends({}, BaseWidgetProps, {
    intervalCount: 1,
    groups: [],
    groupByDate: false,
    groupOrientation: "horizontal",
    crossScrollingEnabled: false,
    startDayHour: 0,
    endDayHour: 24,
    firstDayOfWeek: 0,
    hoursInterval: .5,
    showAllDayPanel: false,
    allDayPanelExpanded: false,
    allowMultipleCellSelection: true,
    indicatorTime: new Date,
    indicatorUpdateInterval: 5 * dateUtils.dateToMilliseconds("minute"),
    shadeUntilCurrentTime: true,
    selectedCellData: [],
    scrolling: {
        mode: "standard"
    },
    cellDuration: 30,
    showCurrentTimeIndicator: true,
    type: "week"
});
export var CurrentViewConfigType = {
    intervalCount: WorkSpaceProps.intervalCount,
    groups: WorkSpaceProps.groups,
    groupByDate: WorkSpaceProps.groupByDate,
    groupOrientation: WorkSpaceProps.groupOrientation,
    crossScrollingEnabled: WorkSpaceProps.crossScrollingEnabled,
    startDayHour: WorkSpaceProps.startDayHour,
    endDayHour: WorkSpaceProps.endDayHour,
    firstDayOfWeek: WorkSpaceProps.firstDayOfWeek,
    hoursInterval: WorkSpaceProps.hoursInterval,
    showAllDayPanel: WorkSpaceProps.showAllDayPanel,
    allDayPanelExpanded: WorkSpaceProps.allDayPanelExpanded,
    allowMultipleCellSelection: WorkSpaceProps.allowMultipleCellSelection,
    indicatorTime: WorkSpaceProps.indicatorTime,
    indicatorUpdateInterval: WorkSpaceProps.indicatorUpdateInterval,
    shadeUntilCurrentTime: WorkSpaceProps.shadeUntilCurrentTime,
    selectedCellData: WorkSpaceProps.selectedCellData,
    scrolling: WorkSpaceProps.scrolling,
    cellDuration: WorkSpaceProps.cellDuration,
    showCurrentTimeIndicator: WorkSpaceProps.showCurrentTimeIndicator,
    type: WorkSpaceProps.type,
    focusStateEnabled: WorkSpaceProps.focusStateEnabled,
    tabIndex: WorkSpaceProps.tabIndex
};
