/**
 * DevExtreme (esm/renovation/ui/scroll_view/utils/get_relative_offset.js)
 * Version: 21.2.0 (build 21230-1556)
 * Build date: Wed Aug 18 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
export function getRelativeOffset(targetElement, sourceElement) {
    var offset = {
        left: 0,
        top: 0
    };
    var currentElement = sourceElement;
    while (null !== (_currentElement = currentElement) && void 0 !== _currentElement && _currentElement.offsetParent && currentElement !== targetElement) {
        var _currentElement;
        var parentOffsetElement = currentElement.offsetParent;
        var currentElementRect = currentElement.getBoundingClientRect();
        var parentOffsetElementRect = parentOffsetElement.getBoundingClientRect();
        offset.left += currentElementRect.left - parentOffsetElementRect.left;
        offset.top += currentElementRect.top - parentOffsetElementRect.top;
        currentElement = currentElement.offsetParent
    }
    return offset
}
